Bug 93405 - FILESAVE Slowdown saving large but simple ODS
Summary: FILESAVE Slowdown saving large but simple ODS
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
4.2.0.4 release
Hardware: Other All
: high minor
Assignee: Markus Mohrhard
URL:
Whiteboard: target:5.2.0
Keywords: bibisected, bisected, filter:ods, perf, regression
Depends on:
Blocks:
 
Reported: 2015-08-13 07:37 UTC by Matthew Francis
Modified: 2016-10-25 19:09 UTC (History)
4 users (show)

See Also:
Crash report or crash signature:
Regression By:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Matthew Francis 2015-08-13 07:37:28 UTC
Split from bug 92802 as there appear to be separate load and save speed regressions for the file

attachment 117292 [details] used to save much faster than at present - initially a few seconds, currently several minutes. Further details on the above original report.
Comment 1 Matthew Francis 2015-08-13 07:40:23 UTC
One commit in a range identified on the original report at which the save time increased significantly is the below. This isn't the earliest speed regression, however.

commit f9704bf73dfba50421132e5379165912a2779906
Author: Kohei Yoshida <kohei.yoshida@gmail.com>
Date:   Tue Jun 25 11:06:43 2013 -0400

    The horizontal cell iterator was *still* broken. Let's fix it again.
    
    And add a test for it.
    
    Change-Id: If76a67e02ac6ad5199d664850bd8591bd3032f32
Comment 2 Matthew Francis 2015-08-13 07:50:36 UTC
There are too many individual fluctuations in the speed of saving this file to make further bisection of much use. It needs hitting with callgrind to analyse the current state / issue(s)
Comment 3 Timur 2015-08-25 11:13:24 UTC
According to https://bugs.documentfoundation.org/show_bug.cgi?id=92802#c0, version set as 4.2.
Comment 4 Robinson Tryon (qubit) 2015-12-10 10:55:33 UTC Comment hidden (obsolete)
Comment 5 Timur 2016-03-24 12:48:31 UTC
It's worse with master~2016-03-22_23.57.30_LibreOfficeDev_5.2.0.0.alpha0_Win_x86: 

version       load  save
4.1.6         16s    12s
4.2.0         20s    25s
5.1.1         32s    1:20 min
5.2+          38s    3:30 min
Comment 6 Commit Notification 2016-03-25 00:53:53 UTC
Markus Mohrhard committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=ee98f0e691e3cf945725a9f1daa90542407e3358

these two methods are identical copies, related tdf#93405

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 7 Commit Notification 2016-03-25 00:53:56 UTC
Markus Mohrhard committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=4518faa31dec03ffabee30437e6960558a940957

we already pass the ScRefCellValue as parameter, tdf#93405

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 8 Commit Notification 2016-03-25 00:54:00 UTC
Markus Mohrhard committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=d9c1921c5031e5b372ee9d8db1e00fe7211cdd31

use the ScRefCellValue that is already available, tdf#93405

It will be available in 5.2.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 9 Markus Mohrhard 2016-03-25 00:55:39 UTC
Export should be more or less instant now.
Comment 10 Timur 2016-03-28 12:06:25 UTC
With master~2016-03-27_09.52.41_LibreOfficeDev_5.2.0.0.alpha0_Win_x86 it takes 18sec for me. 
It's better than it was but still worse than with 4.1.6 and not instant. 
Please comment.